#include <stdlib.h>
#include <stdio.h>
#include "stack.h"
#include "tree.h"
#include "prover.h"

stack *top = NULL;


 void push (tnode *to_stack) {
   stack *aux = malloc(sizeof(stack));
    
   aux->node = to_stack;
   aux->next = top;
      
   top = aux;
}

// retira da pilha e na funcao que chama seta os pais
void pop () {
   stack *aux;

   aux = top;
   top = top->next;
   free(aux);
}

void print_stack () {
   stack *aux;
   aux = top;
   int vazio = 1;
   
   while (aux != NULL) {
     printf ("\npilha: %d", aux->node->id);
     aux = aux->next;
     vazio = 0;
   }
   if (vazio)
        printf ("\npilha vazia");
   printf ("\n");
}

void add_up(tnode *dad) {
  int i;
  int loop = 0;

  if (dad->type == CONJUNCTION || dad->type == DISJUNCTION) {
      loop=2;
  }
  if (dad->type == NEGATION || dad->type == BOX || dad->type == DIAMOND) {
    loop=1;
  }
  //colocar no primeiro if
  if (dad->type == IMPLICATION || dad->type == DOUBLEIMP) {
    loop=2;
  }
  if (dad->type == PROP || dad->type == CONSTANT) {
    printf("We have a problem, Houston. Printing the tree.\n");
  }
  
  for (i=0; i<loop; i++) {
    top->node->up = dad;
    pop();
  }
}

void print_tree_up(tnode *s) {  
 // int i;
 // int size1, size2;
 //printf ("[tree.c] print_tree\n");
  //getchar();
  
    // anda ate o final da arvore
    while (s!=NULL) {
        s = s->right;
    }

    while (s!=NULL) {
        printf("(id:%d,vn:%u,md:%d,ml:%d,pol:%d)\n",s->id,s->value_number,s->mdepth,s->mlevel,s->polarity);
        s = s->up;
    }
  

/*for (i=0;i<indentation;i++) printf(" ");
  
    switch (s->type) {
    case SETF:
      if (s->id == SOS) 
	printf("\n\n Conjunction of formulae in the SOS:\n");
      else if (s->id == USABLE)
	printf("\n\n Conjunction of formulae in the Usable:\n");
      print_tree(s->left);
      print_tree(s->right);
      break;
    case SETC:
      if (s->id == SOS) 
	printf("\n\n Conjunction of clauses in the SOS:\n");
      else if (s->id == USABLE)
	printf("\n\n Conjunction of clauses in the Usable:\n");
      print_tree(s->left);
      print_tree(s->right);
      break;	  
    case CONSTANT:
      if (s->id == CTRUE) printf("TRUE (id:%d,vn:%u,md:%d,ml:%d,pol:%d)\n",s->id,s->value_number,s->mdepth,s->mlevel,s->polarity);
      else if (s->id == CFALSE) printf("FALSE (id:%d,vn:%u,md:%d,ml:%d,pol:%d)\n",s->id,s->value_number,s->mdepth,s->mlevel,s->polarity);
      else if (s->id == CSTART) printf("START (id:%d,vn:%u,md:%d,ml:%d,pol:%d)\n",s->id,s->value_number,s->mdepth,s->mlevel,s->polarity);
      return 1;
      break;
    case PROP: 
      printf("PROPOSITION: ");
      print_prop(s->id);
      printf(" (id:%d,vn:%u,md:%d,ml:%d,pol:%d)\n",s->id,s->value_number,s->mdepth,s->mlevel,s->polarity); 
      return 1;
      break;
    case BOX:
      printf("MODAL: ");
      print_agent(s->id);
      printf(" (id:%d,vn:%u,md:%d,ml:%d,pol:%d)\n",s->id,s->value_number,s->mdepth,s->mlevel,s->polarity);
      indentation += tab;
      size1 = print_tree(s->left);
      indentation -= tab;
      return size1 + 1;
      break;
    case DIAMOND:
      printf("MODAL: ~ ");
      print_agent(s->id);
      printf(" ~ (id:%d,vn:%u,md:%d,ml:%d,pol:%d)\n",s->id,s->value_number,s->mdepth,s->mlevel,s->polarity); 
      indentation += tab;
      size1 = print_tree(s->left);
      indentation -= tab;
      return size1 + 1;
      break;
    case NEGATION: 
      printf("NEGATION");
      printf(" (id:%d,vn:%u,md:%d,ml:%d,pol:%d)\n",s->id,s->value_number,s->mdepth,s->mlevel,s->polarity); 
      indentation += tab;
      size1 = print_tree(s->left);
      indentation -= tab;
      return size1 + 1;
      break;
    case CONJUNCTION:
      printf("CONJUNCTION");
      printf(" (id:%d,vn:%u,md:%d,ml:%d,pol:%d)\n",s->id,s->value_number,s->mdepth,s->mlevel,s->polarity); 
      indentation += tab;
      size1 = print_list(s->list);
      indentation -= tab;
      return size1 + 1;
      break;
    case DISJUNCTION:
      printf("DISJUNCTION");
      printf(" (id:%d,vn:%u,md:%d,ml:%d,pol:%d)\n",s->id,s->value_number,s->mdepth,s->mlevel,s->polarity); 
      indentation += tab;
      size1 = print_list(s->list);
      indentation -= tab;
      return size1 + 1;
      break;
    case IMPLICATION:
      printf("IMPLICATION");
      printf(" (id:%d,vn:%u,md:%d,ml:%d,pol:%d)\n",s->id,s->value_number,s->mdepth,s->mlevel,s->polarity); 
      indentation += tab;
      size1 = print_tree(s->left);
      size2 = print_tree(s->right);
      indentation -= tab;
      return size1 + size2 + 1;
      break;
    case DOUBLEIMP:
      printf("DOUBLE IMPLICATION");
      printf(" (id:%d,vn:%u,md:%d,ml:%d,pol:%d)\n",s->id,s->value_number,s->mdepth,s->mlevel,s->polarity); 
      indentation += tab;
      size1 = print_tree(s->left);
      size2 = print_tree(s->right);
      indentation -= tab;
      return size1 + size2 + 1;
      break;
    default:
      printf("We have a problem, Houston. Printing the tree.\n");
    }
  }

  return 0;
*/
}

//#define PROP        0
//#define BOX         1
//#define DIAMOND     2
//#define NEGATION    3
//#define CONJUNCTION 4
//#define DISJUNCTION 5
//#define IMPLICATION 6
//#define DOUBLEIMP   7
//#define CONSTANT    8









